#!/usr/bin/env perl
use Mojolicious::Lite;
use Data::Dumper;

use google;
use config;
use frame;

# Documentation browser under "/perldoc"
plugin 'PODRenderer';
plugin 'RenderFile';

# Secret
app->secret('*7i78(v%ec4e3s5*7i78(v%ec4e3s5D6vb6nc4e3s5D6vb6n');

# Настройка гипножабы
app->config(hypnotoad => {listen => ['http://*:80']});

# Хуки
hook after_dispatch => sub {
	my $self = shift;
	frame::save('logs/main.txt.log', $self->whois."\n");

	for (glob('tmp/*.txt')) {
		unlink($_) if (-A $_ >= 1.0);
	}
};

# Хелперы
helper whois => sub {
	my $self  = shift;
	my $agent = $self->req->headers->user_agent || 'Anonymous';
	my $ip = $self->tx->remote_address;
	return $self->req->url->to_abs.' | '.$agent.' | '.$ip;
};

get '/' => sub {
	my $self = shift;
	return $self->redirect_to('login') unless $self->session('name');
	$self->render;
} => 'search';

get '/search/' => sub {
	my $self = shift;
	return $self->redirect_to('login') unless $self->session('name');
	return $self->render;
} => 'search';

post '/search/' => sub {
	my $self = shift;
	return $self->redirect_to('login') unless $self->session('name');

	my $search = $self->param('q')||'Ты тампон';
	my $pages = $self->param('p') || 1;

	if ($search and $pages) {
		my $links = join("\n", google::run($search, $pages));
		my $fileName = frame::getRandomName();
		frame::save('tmp/'.$fileName, $links);
		$self->render(dataText => $links, file => $fileName);
	} else {
		$self->render(dataText => 'Warning parametrs!');
	}
} => 'result';

get '/download' => sub {
	my $self = shift;
	return $self->redirect_to('login') unless $self->session('name');
	my $file = $self->param('f');
	return '' unless ($file or -f $file);
	return $self->render_file(
		filepath => 'tmp/'.$file,
		filename => $file
	);
} => 'error';

get '/login/' => 'login';
post '/login/' => sub {
	my $self = shift;
	my %conf = config::admin();

	my $login = $self->param('login') || '';
	my $password = $self->param('password') || '';

	if ($conf{login} eq $login and $conf{password} eq $password) {
		$self->session(name => $login);
		$self->flash(message => 'Вы успешно вошли в систему!');
		$self->redirect_to('/search');
	} else {
		return $self->render;
	}
} => 'login';

get '/logout' => sub {
	my $self = shift;
	$self->session(expires => 1);
	$self->redirect_to('login');
} => 'logout';

app->start;